Index: /pjproject/trunk/pjlib/include/pj++/list.hpp
===================================================================
--- /pjproject/trunk/pjlib/include/pj++/list.hpp	(revision 126)
+++ /pjproject/trunk/pjlib/include/pj++/list.hpp	(revision 127)
@@ -64,5 +64,5 @@
 	const_iterator operator++() 
         { 
-            return const_iterator(node_->next); 
+            return const_iterator((const List_Node *)node_->next); 
         }
 	bool operator==(const const_iterator &rhs) 
@@ -100,5 +100,5 @@
 	iterator operator++() 
         { 
-            return iterator(node_->next); 
+            return iterator((List_Node*)node_->next); 
         }
 	bool operator==(const iterator &rhs) 
@@ -122,4 +122,28 @@
 
     //
+    // You can cast Pj_List to pj_list
+    //
+    operator pj_list&()
+    {
+	return (pj_list&)root_;
+    }
+    operator const pj_list&()
+    {
+	return (const pj_list&)root_;
+    }
+
+    //
+    // You can cast Pj_List to pj_list* too
+    //
+    operator pj_list*()
+    {
+	return (pj_list*)&root_;
+    }
+    operator const pj_list*()
+    {
+	return (const pj_list*)&root_;
+    }
+
+    //
     // Check if list is empty.
     // 
@@ -319,5 +343,5 @@
 	// it's because List_Node is not derived from Pj_List_Node.
 	List_Node *n = (List_Node*)0;
-	n = n->next; n = n->prev;
+	n = (List_Node *)n->next; n = (List_Node *)n->prev;
     }
 };
Index: /pjproject/trunk/pjlib/include/pj++/pool.hpp
===================================================================
--- /pjproject/trunk/pjlib/include/pj++/pool.hpp	(revision 126)
+++ /pjproject/trunk/pjlib/include/pj++/pool.hpp	(revision 127)
@@ -124,4 +124,12 @@
 
     //
+    // You can cast Pj_Pool to pj_pool_t*
+    //
+    operator pj_pool_t*()
+    {
+	return p_;
+    }
+
+    //
     // Get pjlib compatible pool object.
     //
Index: /pjproject/trunk/pjlib/include/pj++/string.hpp
===================================================================
--- /pjproject/trunk/pjlib/include/pj++/string.hpp	(revision 126)
+++ /pjproject/trunk/pjlib/include/pj++/string.hpp	(revision 127)
@@ -41,7 +41,7 @@
 
     //
-    // Construct the buffer from a char*.
-    //
-    explicit Pj_String(char *str) 
+    // Construct the buffer from a char* (use with care)
+    //
+    Pj_String(char *str) 
     { 
 	set(str);
@@ -51,5 +51,5 @@
     // Construct from a const char*.
     //
-    Pj_String(Pj_Pool *pool, const char *src)
+    Pj_String(Pj_Pool &pool, const char *src)
     {
 	set(pool, src);
@@ -57,9 +57,19 @@
 
     //
-    // Construct from pj_str_t*.
-    //
-    explicit Pj_String(pj_str_t *s)
-    {
-	set(s);
+    // Construct from pj_str_t&.
+    //
+    explicit Pj_String(pj_str_t &s)
+    {
+	ptr = s.ptr;
+	slen = s.slen;
+    }
+
+    //
+    // Construct from const pj_str_t& (use with care!).
+    //
+    explicit Pj_String(const pj_str_t &s)
+    {
+	ptr = (char*)s.ptr;
+	slen = s.slen;
     }
 
@@ -67,5 +77,5 @@
     // Construct by copying from const pj_str_t*.
     //
-    Pj_String(Pj_Pool *pool, const pj_str_t *s)
+    Pj_String(Pj_Pool &pool, const pj_str_t *s)
     {
 	set(pool, s);
@@ -73,15 +83,7 @@
 
     //
-    // Construct from another Pj_String
-    //
-    explicit Pj_String(Pj_String &rhs)
-    {
-	set(rhs);
-    }
-
-    //
     // Construct by copying from Pj_String
     //
-    Pj_String(Pj_Pool *pool, const Pj_String &rhs)
+    Pj_String(Pj_Pool &pool, const Pj_String &rhs)
     {
 	set(pool, rhs);
@@ -89,4 +91,13 @@
 
     //
+    // Construct from another Pj_String, use with care!
+    //
+    explicit Pj_String(const Pj_String &rhs)
+    {
+	ptr = rhs.ptr;
+	slen = rhs.slen;
+    }
+
+    //
     // Construct from a char* and a length.
     //
@@ -105,4 +116,20 @@
 
     //
+    // You can cast Pj_String to pj_str_t*
+    //
+    operator pj_str_t*()
+    {
+	return this;
+    }
+
+    //
+    // You can cast const Pj_String to const pj_str_t*
+    //
+    operator const pj_str_t*() const
+    {
+	return this;
+    }
+
+    //
     // Get the length of the string.
     //
@@ -139,7 +166,7 @@
     // Initialize by copying from a const char*.
     //
-    void set(Pj_Pool *pool, const char *s)
-    {
-	pj_strdup2(pool->pool_(), this, s);
+    void set(Pj_Pool &pool, const char *s)
+    {
+	pj_strdup2(pool, this, s);
     }
 
@@ -155,7 +182,7 @@
     // Initialize by copying from const pj_str_t*.
     //
-    void set(Pj_Pool *pool, const pj_str_t *s)
-    {
-	pj_strdup(pool->pool_(), this, s);
+    void set(Pj_Pool &pool, const pj_str_t *s)
+    {
+	pj_strdup(pool, this, s);
     }
 
@@ -187,7 +214,7 @@
     // Initialize by copying from a Pj_String*.
     //
-    void set(Pj_Pool *pool, const Pj_String *s)
-    {
-	pj_strdup(pool->pool_(), this, s);
+    void set(Pj_Pool &pool, const Pj_String *s)
+    {
+	pj_strdup(pool, this, s);
     }
 
@@ -195,7 +222,7 @@
     // Initialize by copying from other Pj_String.
     //
-    void set(Pj_Pool *pool, const Pj_String &s)
-    {
-	pj_strdup(pool->pool_(), this, &s);
+    void set(Pj_Pool &pool, const Pj_String &s)
+    {
+	pj_strdup(pool, this, &s);
     }
 
@@ -354,9 +381,10 @@
 
     ///
-    // Assign from another Pj_String
-    //
-    Pj_String& operator=(Pj_String &rhs)
-    {
-	set(rhs);
+    // Assign from another Pj_String, use with care!
+    //
+    Pj_String& operator=(const Pj_String &rhs)
+    {
+	ptr = rhs.ptr;
+	slen = rhs.slen;
 	return *this;
     }
Index: /pjproject/trunk/pjlib/include/pj++/types.hpp
===================================================================
--- /pjproject/trunk/pjlib/include/pj++/types.hpp	(revision 126)
+++ /pjproject/trunk/pjlib/include/pj++/types.hpp	(revision 127)
@@ -157,4 +157,18 @@
 };
 
+//
+// Macro to declare common object comparison operators.
+//
+#define PJ_DECLARE_OPERATORS(rhs_type)			    \
+	    bool operator!=(rhs_type rhs) const {	    \
+		return !operator==(rhs); }		    \
+	    bool operator<=(rhs_type rhs) const {	    \
+		return operator<(rhs) || operator==(rhs); } \
+	    bool operator>(rhs_type rhs) const {	    \
+		return !operator<=(rhs); }		    \
+	    bool operator>=(rhs_type rhs) const {	    \
+		return !operator<(rhs); }
+
+
 #endif	/* __PJPP_TYPES_HPP__ */
 
Index: /pjproject/trunk/pjlib/include/pj/assert.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/assert.h	(revision 126)
+++ /pjproject/trunk/pjlib/include/pj/assert.h	(revision 127)
@@ -50,5 +50,5 @@
 /**
  * @hideinitializer
- * If #PJ_ENABLE_EXTRA_CHECK is declared and non-zero, then 
+ * If #PJ_ENABLE_EXTRA_CHECK is declared and the value is non-zero, then 
  * #PJ_ASSERT_RETURN macro will evaluate the expression in @a expr during
  * run-time. If the expression yields false, assertion will be triggered
Index: /pjproject/trunk/pjlib/include/pj/hash.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/hash.h	(revision 126)
+++ /pjproject/trunk/pjlib/include/pj/hash.h	(revision 127)
@@ -46,4 +46,9 @@
 
 /**
+ * This indicates the size of of each hash entry.
+ */
+#define PJ_HASH_ENTRY_SIZE	(3*sizeof(void*) + 2*sizeof(pj_uint32_t))
+
+/**
  * This is the function that is used by the hash table to calculate hash value
  * of the specified key.
@@ -93,13 +98,22 @@
  * @param keylen    the length of the key, or PJ_HASH_KEY_STRING to use the
  *		    string length of the key.
+ * @param hval	    if this argument is not NULL and the value is not zero,
+ *		    the value will be used as the computed hash value. If
+ *		    the argument is not NULL and the value is zero, it will
+ *		    be filled with the computed hash upon return.
  *
  * @return the value associated with the key, or NULL if the key is not found.
  */
 PJ_DECL(void *) pj_hash_get( pj_hash_table_t *ht,
-			     const void *key, unsigned keylen );
-
-
-/**
- * Associate/disassociate a value with the specified key.
+			     const void *key, unsigned keylen,
+			     pj_uint32_t *hval );
+
+
+/**
+ * Associate/disassociate a value with the specified key. If value is not
+ * NULL and entry already exists, the entry's value will be overwritten.
+ * If value is not NULL and entry does not exist, a new one will be created
+ * with the specified pool. Otherwise if value is NULL, entry will be
+ * deleted if it exists.
  *
  * @param pool	    the pool to allocate the new entry if a new entry has to be
@@ -109,10 +123,41 @@
  * @param keylen    the length of the key, or PJ_HASH_KEY_STRING to use the 
  *		    string length of the key.
+ * @param hval	    if the value is not zero, then the hash table will use
+ *		    this value to search the entry's index, otherwise it will
+ *		    compute the key. This value can be obtained when calling
+ *		    #pj_hash_get().
  * @param value	    value to be associated, or NULL to delete the entry with
  *		    the specified key.
  */
 PJ_DECL(void) pj_hash_set( pj_pool_t *pool, pj_hash_table_t *ht,
-			   const void *key, unsigned keylen,
+			   const void *key, unsigned keylen, pj_uint32_t hval,
 			   void *value );
+
+
+/**
+ * Associate/disassociate a value with the specified key. This function works
+ * like #pj_hash_set(), except that it doesn't use pool (hence the np -- no 
+ * pool suffix). If new entry needs to be allocated, it will use the entry_buf.
+ *
+ * @param ht	    the hash table.
+ * @param key	    the key.
+ * @param keylen    the length of the key, or PJ_HASH_KEY_STRING to use the 
+ *		    string length of the key.
+ * @param hval	    if the value is not zero, then the hash table will use
+ *		    this value to search the entry's index, otherwise it will
+ *		    compute the key. This value can be obtained when calling
+ *		    #pj_hash_get().
+ * @param entry_buf Pointer to buffer which will be used for the new entry,
+ *		    when one needs to be created. The buffer must be at least
+ *		    PJ_HASH_ENTRY_SIZE long, and the first PJ_HASH_ENTRY_SIZE
+ *		    bytes of the buffer will be used by the hash table.
+ *		    Application may use the remaining portion of the buffer
+ *		    for its own purpose.
+ * @param value	    value to be associated, or NULL to delete the entry with
+ *		    the specified key.
+ */
+PJ_DECL(void) pj_hash_set_np(pj_hash_table_t *ht,
+			     const void *key, unsigned keylen, 
+			     pj_uint32_t hval, void *entry_buf, void *value);
 
 /**
Index: /pjproject/trunk/pjlib/src/pj/hash.c
===================================================================
--- /pjproject/trunk/pjlib/src/pj/hash.c	(revision 126)
+++ /pjproject/trunk/pjlib/src/pj/hash.c	(revision 127)
@@ -23,4 +23,5 @@
 #include <pj/os.h>
 #include <pj/ctype.h>
+#include <pj/assert.h>
 
 /**
@@ -58,5 +59,4 @@
 	    hash = hash * PJ_HASH_MULTIPLIER + *p;
 	}
-	keylen = p - (const unsigned char*)key;
     } else {
 	const unsigned char *p = key,
@@ -89,4 +89,7 @@
     unsigned table_size;
     
+    /* Check that PJ_HASH_ENTRY_SIZE is correct. */
+    PJ_ASSERT_RETURN(sizeof(pj_hash_entry)==PJ_HASH_ENTRY_SIZE, NULL);
+
     h = pj_pool_alloc(pool, sizeof(pj_hash_table_t));
     h->count = 0;
@@ -111,22 +114,34 @@
 static pj_hash_entry **find_entry( pj_pool_t *pool, pj_hash_table_t *ht, 
 				   const void *key, unsigned keylen,
-				   void *val)
+				   void *val, pj_uint32_t *hval,
+				   void *entry_buf)
 {
     pj_uint32_t hash;
     pj_hash_entry **p_entry, *entry;
 
-    hash=0;
-    if (keylen==PJ_HASH_KEY_STRING) {
-	const unsigned char *p = key;
-	for ( ; *p; ++p ) {
-	    hash = hash * PJ_HASH_MULTIPLIER + *p;
-	}
-	keylen = p - (const unsigned char*)key;
+    if (hval && *hval != 0) {
+	hash = *hval;
     } else {
-	const unsigned char *p = key,
-			    *end = p + keylen;
-	for ( ; p!=end; ++p) {
-	    hash = hash * PJ_HASH_MULTIPLIER + *p;
-	}
+	/* This slightly differs with pj_hash_calc() because we need 
+	 * to get the keylen when keylen is PJ_HASH_KEY_STRING.
+	 */
+	hash=0;
+	if (keylen==PJ_HASH_KEY_STRING) {
+	    const unsigned char *p = key;
+	    for ( ; *p; ++p ) {
+		hash = hash * PJ_HASH_MULTIPLIER + *p;
+	    }
+	    keylen = p - (const unsigned char*)key;
+	} else {
+	    const unsigned char *p = key,
+				*end = p + keylen;
+	    for ( ; p!=end; ++p) {
+		hash = hash * PJ_HASH_MULTIPLIER + *p;
+	    }
+	}
+
+	/* Report back the computed hash. */
+	if (hval)
+	    *hval = hash;
     }
 
@@ -137,5 +152,5 @@
     {
 	if (entry->hash==hash && entry->keylen==keylen &&
-	    memcmp(entry->key, key, keylen)==0) 
+	    pj_memcmp(entry->key, key, keylen)==0) 
 	{
 	    break;	
@@ -146,8 +161,19 @@
 	return p_entry;
 
-    /* create a new entry */
-    entry = pj_pool_alloc(pool, sizeof(pj_hash_entry));
-    PJ_LOG(6, ("hashtbl", "%p: New p_entry %p created, pool used=%u, cap=%u", ht, entry, 
-			  pj_pool_get_used_size(pool), pj_pool_get_capacity(pool)));
+    /* Entry not found, create a new one. 
+     * If entry_buf is specified, use it. Otherwise allocate from pool.
+     */
+    if (entry_buf) {
+	entry = entry_buf;
+    } else {
+	/* Pool must be specified! */
+	PJ_ASSERT_RETURN(pool != NULL, NULL);
+
+	entry = pj_pool_alloc(pool, sizeof(pj_hash_entry));
+	PJ_LOG(6, ("hashtbl", 
+		   "%p: New p_entry %p created, pool used=%u, cap=%u", 
+		   ht, entry,  pj_pool_get_used_size(pool), 
+		   pj_pool_get_capacity(pool)));
+    }
     entry->next = NULL;
     entry->hash = hash;
@@ -163,18 +189,21 @@
 
 PJ_DEF(void *) pj_hash_get( pj_hash_table_t *ht,
-			    const void *key, unsigned keylen )
+			    const void *key, unsigned keylen,
+			    pj_uint32_t *hval)
 {
     pj_hash_entry *entry;
-    entry = *find_entry( NULL, ht, key, keylen, NULL);
+
+    if (hval) *hval = 0;
+    entry = *find_entry( NULL, ht, key, keylen, NULL, hval, NULL);
     return entry ? entry->value : NULL;
 }
 
 PJ_DEF(void) pj_hash_set( pj_pool_t *pool, pj_hash_table_t *ht,
-			  const void *key, unsigned keylen,
+			  const void *key, unsigned keylen, pj_uint32_t hval,
 			  void *value )
 {
     pj_hash_entry **p_entry;
 
-    p_entry = find_entry( pool, ht, key, keylen, value );
+    p_entry = find_entry( pool, ht, key, keylen, value, &hval, NULL);
     if (*p_entry) {
 	if (value == NULL) {
@@ -187,5 +216,29 @@
 	    /* overwrite */
 	    (*p_entry)->value = value;
-	    PJ_LOG(6, ("hashtbl", "%p: p_entry %p value set to %p", ht, *p_entry, value));
+	    PJ_LOG(6, ("hashtbl", "%p: p_entry %p value set to %p", ht, 
+		       *p_entry, value));
+	}
+    }
+}
+
+PJ_DEF(void) pj_hash_set_np( pj_hash_table_t *ht,
+			     const void *key, unsigned keylen, 
+			     pj_uint32_t hval, void *entry_buf, void *value)
+{
+    pj_hash_entry **p_entry;
+
+    p_entry = find_entry( NULL, ht, key, keylen, value, &hval, entry_buf );
+    if (*p_entry) {
+	if (value == NULL) {
+	    /* delete entry */
+	    PJ_LOG(6, ("hashtbl", "%p: p_entry %p deleted", ht, *p_entry));
+	    *p_entry = (*p_entry)->next;
+	    --ht->count;
+	    
+	} else {
+	    /* overwrite */
+	    (*p_entry)->value = value;
+	    PJ_LOG(6, ("hashtbl", "%p: p_entry %p value set to %p", ht, 
+		       *p_entry, value));
 	}
     }
Index: /pjproject/trunk/pjsip/build/pjsip.dsw
===================================================================
--- /pjproject/trunk/pjsip/build/pjsip.dsw	(revision 126)
+++ /pjproject/trunk/pjsip/build/pjsip.dsw	(revision 127)
@@ -5,4 +5,16 @@
 
 Project: "pjlib"=..\..\pjlib\build\pjlib.dsp - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
+}}}
+
+###############################################################################
+
+Project: "pjlib++"="..\..\pjlib\build\pjlib++.dsp" - Package Owner=<4>
 
 Package=<5>
@@ -29,4 +41,16 @@
 
 Project: "pjmedia"=..\..\pjmedia\build\pjmedia.dsp - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
+}}}
+
+###############################################################################
+
+Project: "pjsip++"=".\pjsip++.dsp" - Package Owner=<4>
 
 Package=<5>
Index: /pjproject/trunk/pjsip/build/pjsip_core.dsp
===================================================================
--- /pjproject/trunk/pjsip/build/pjsip_core.dsp	(revision 126)
+++ /pjproject/trunk/pjsip/build/pjsip_core.dsp	(revision 127)
@@ -86,4 +86,71 @@
 
 # PROP Default_Filter "cpp;c;cxx;rc;def;r;odl;idl;hpj;bat"
+# Begin Group "Base (.c)"
+
+# PROP Default_Filter ""
+# Begin Source File
+
+SOURCE=..\src\pjsip\sip_errno.c
+# End Source File
+# End Group
+# Begin Group "Messaging and Parsing (.c)"
+
+# PROP Default_Filter ""
+# Begin Source File
+
+SOURCE=..\src\pjsip\sip_msg.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\src\pjsip\sip_parser.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\src\pjsip\sip_tel_uri.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\src\pjsip\sip_uri.c
+# End Source File
+# End Group
+# Begin Group "Core (.c)"
+
+# PROP Default_Filter ""
+# Begin Source File
+
+SOURCE=..\src\pjsip\sip_endpoint.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\src\pjsip\sip_util.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\src\pjsip\sip_util_proxy.c
+# End Source File
+# End Group
+# Begin Group "Transport Layer (.c)"
+
+# PROP Default_Filter ""
+# Begin Source File
+
+SOURCE=..\src\pjsip\sip_resolve.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\src\pjsip\sip_transport.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\src\pjsip\sip_transport_loop.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\src\pjsip\sip_transport_udp.c
+# End Source File
+# End Group
+# Begin Group "Authentication (.c)"
+
+# PROP Default_Filter ""
 # Begin Source File
 
@@ -102,55 +169,11 @@
 SOURCE=..\src\pjsip\sip_auth_server.c
 # End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_endpoint.c
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_errno.c
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_msg.c
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_parser.c
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_resolve.c
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_tel_uri.c
-# End Source File
+# End Group
+# Begin Group "Transaction Layer (.c)"
+
+# PROP Default_Filter ""
 # Begin Source File
 
 SOURCE=..\src\pjsip\sip_transaction.c
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_transport.c
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_transport_loop.c
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_transport_udp.c
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_uri.c
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_util.c
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_util_proxy.c
 # End Source File
 # Begin Source File
@@ -160,11 +183,43 @@
 # End Source File
 # End Group
+# Begin Group "UA Layer (.c)"
+
+# PROP Default_Filter ""
+# Begin Source File
+
+SOURCE=..\src\pjsip\sip_dialog.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\src\pjsip\sip_ua_layer.c
+# End Source File
+# End Group
+# End Group
 # Begin Group "Header Files"
 
 # PROP Default_Filter "h;hpp;hxx;hm;inl"
-# Begin Source File
-
-SOURCE=..\include\pjsip_core.h
-# End Source File
+# Begin Group "Base Types (.h)"
+
+# PROP Default_Filter ""
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_config.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_errno.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_private.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_types.h
+# End Source File
+# End Group
+# Begin Group "Messaging and Parsing (.h)"
+
+# PROP Default_Filter ""
 # Begin Source File
 
@@ -173,4 +228,64 @@
 # Begin Source File
 
+SOURCE=..\include\pjsip\sip_msg.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_parser.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_tel_uri.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_uri.h
+# End Source File
+# End Group
+# Begin Group "Core (.h)"
+
+# PROP Default_Filter ""
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_endpoint.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_event.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_module.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_util.h
+# End Source File
+# End Group
+# Begin Group "Transport Layer (.h)"
+
+# PROP Default_Filter ""
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_resolve.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_transport.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_transport_loop.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_transport_udp.h
+# End Source File
+# End Group
+# Begin Group "Authentication (.h)"
+
+# PROP Default_Filter ""
+# Begin Source File
+
 SOURCE=..\include\pjsip\sip_auth.h
 # End Source File
@@ -183,71 +298,28 @@
 SOURCE=..\include\pjsip\sip_auth_parser.h
 # End Source File
-# Begin Source File
-
-SOURCE=..\include\pjsip\sip_config.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\pjsip\sip_endpoint.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\pjsip\sip_errno.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\pjsip\sip_event.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\pjsip\sip_module.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\pjsip\sip_msg.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\pjsip\sip_parser.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\pjsip\sip_private.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\pjsip\sip_resolve.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\pjsip\sip_tel_uri.h
-# End Source File
+# End Group
+# Begin Group "Transaction Layer (.h)"
+
+# PROP Default_Filter ""
 # Begin Source File
 
 SOURCE=..\include\pjsip\sip_transaction.h
 # End Source File
-# Begin Source File
-
-SOURCE=..\include\pjsip\sip_transport.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\pjsip\sip_transport_loop.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\pjsip\sip_transport_udp.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\pjsip\sip_types.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\pjsip\sip_uri.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\pjsip\sip_util.h
+# End Group
+# Begin Group "UA Layer (.h)"
+
+# PROP Default_Filter ""
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_dialog.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_ua_layer.h
+# End Source File
+# End Group
+# Begin Source File
+
+SOURCE=..\include\pjsip.h
 # End Source File
 # End Group
Index: /pjproject/trunk/pjsip/build/pjsip_ua.dsp
===================================================================
--- /pjproject/trunk/pjsip/build/pjsip_ua.dsp	(revision 126)
+++ /pjproject/trunk/pjsip/build/pjsip_ua.dsp	(revision 127)
@@ -88,17 +88,14 @@
 # Begin Source File
 
-SOURCE="..\src\pjsip-ua\sip_dialog.c"
-# End Source File
-# Begin Source File
+SOURCE="..\src\pjsip-ua\sip_reg.c"
 
-SOURCE="..\src\pjsip-ua\sip_reg.c"
-# End Source File
-# Begin Source File
+!IF  "$(CFG)" == "pjsip_ua - Win32 Release"
 
-SOURCE="..\src\pjsip-ua\sip_ua.c"
-# End Source File
-# Begin Source File
+!ELSEIF  "$(CFG)" == "pjsip_ua - Win32 Debug"
 
-SOURCE="..\src\pjsip-ua\sip_ua_private.h"
+# PROP Exclude_From_Build 1
+
+!ENDIF 
+
 # End Source File
 # End Group
@@ -108,13 +105,5 @@
 # Begin Source File
 
-SOURCE="..\include\pjsip-ua\sip_dialog.h"
-# End Source File
-# Begin Source File
-
 SOURCE="..\include\pjsip-ua\sip_regc.h"
-# End Source File
-# Begin Source File
-
-SOURCE="..\include\pjsip-ua\sip_ua.h"
 # End Source File
 # End Group
Index: /pjproject/trunk/pjsip/build/test_pjsip.dsp
===================================================================
--- /pjproject/trunk/pjsip/build/test_pjsip.dsp	(revision 126)
+++ /pjproject/trunk/pjsip/build/test_pjsip.dsp	(revision 127)
@@ -90,4 +90,8 @@
 # Begin Source File
 
+SOURCE="..\src\test-pjsip\dlg_core_test.c"
+# End Source File
+# Begin Source File
+
 SOURCE="..\src\test-pjsip\main.c"
 # End Source File
Index: /pjproject/trunk/pjsip/include/pjsip.h
===================================================================
--- /pjproject/trunk/pjsip/include/pjsip.h	(revision 127)
+++ /pjproject/trunk/pjsip/include/pjsip.h	(revision 127)
@@ -0,0 +1,56 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2003-2006 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#ifndef __PJSIP_H__
+#define __PJSIP_H__
+
+/* Base types. */
+#include <pjsip/sip_types.h>
+#include <pjsip/sip_errno.h>
+
+/* Messaging and parsing. */
+#include <pjsip/sip_uri.h>
+#include <pjsip/sip_tel_uri.h>
+#include <pjsip/sip_msg.h>
+#include <pjsip/sip_parser.h>
+
+/* Core */
+#include <pjsip/sip_event.h>
+#include <pjsip/sip_module.h>
+#include <pjsip/sip_endpoint.h>
+#include <pjsip/sip_util.h>
+
+/* Transport layer */
+#include <pjsip/sip_transport.h>
+#include <pjsip/sip_transport_udp.h>
+#include <pjsip/sip_transport_loop.h>
+#include <pjsip/sip_resolve.h>
+
+/* Authentication. */
+#include <pjsip/sip_auth.h>
+
+/* Transaction layer. */
+#include <pjsip/sip_transaction.h>
+
+/* UA Layer. */
+#include <pjsip/sip_ua_layer.h>
+#include <pjsip/sip_dialog.h>
+
+
+#endif	/* __PJSIP_H__ */
+
Index: /pjproject/trunk/pjsip/include/pjsip/sip_auth.h
===================================================================
--- /pjproject/trunk/pjsip/include/pjsip/sip_auth.h	(revision 126)
+++ /pjproject/trunk/pjsip/include/pjsip/sip_auth.h	(revision 127)
@@ -188,4 +188,16 @@
 
 
+/**
+ * Clone client initialization session. 
+ *
+ * @param pool		Pool to use.
+ * @param sess		Structure to put the duplicated session.
+ * @param rhs		The client session to be cloned.
+ *
+ * @return		PJ_SUCCESS on success;
+ */
+PJ_DECL(pj_status_t) pjsip_auth_clt_clone( pj_pool_t *pool,
+					   pjsip_auth_clt_sess *sess,
+					   const pjsip_auth_clt_sess *rhs);
 
 /**
Index: /pjproject/trunk/pjsip/include/pjsip/sip_config.h
===================================================================
--- /pjproject/trunk/pjsip/include/pjsip/sip_config.h	(revision 126)
+++ /pjproject/trunk/pjsip/include/pjsip/sip_config.h	(revision 127)
@@ -53,4 +53,8 @@
 #define PJSIP_POOL_TSX_INC		256
 #define PJSIP_MAX_TSX_KEY_LEN		(PJSIP_MAX_URL_SIZE*2)
+
+/* User agent. */
+#define PJSIP_POOL_LEN_USER_AGENT	1024
+#define PJSIP_POOL_INC_USER_AGENT	1024
 
 /* Message/URL related constants. */
